import CamelElement from "../CamelElement";
import { Resources } from "../../utility";
class Loop extends CamelElement {
  constructor() {
    super();
    this.scope = "Loop";
    this.parent = "";
    this.inputid = ""; // 线的接入
    this.outputid = ""; // 线的出口
    this.id = "_loop";
    this.description = "";
    this.copy = false;
    this.doWhile = false;
  }

  paint(g) {
    if (this._img == null) {
      this._img = Resources.IMG_START_NODE;
    }

    g.save();
    this.color = "#cebee1";
    g.drawOvalBorder(this.x, this.y, this.width, this.height, 10, this.color);
    g.drawImage(this._img, this.x + 10, this.y + 5, this.icon_width / 2, this.icon_height / 2);
    g.setColor(Resources.COLOR.black);
    g.drawText("Loop" + this.id, this.x + this.width / 6, this.y + this.height / 1.5);
    g.restore();
  }

  toXML() {
    let str = "";
    if (this.expression)
      str += `<loop id="${this.id}" x="${this.x}" y="${this.y}" scope="${this.scope}" description="${this.description}" expression="${this.expression}"  copy="${this.copy}" doWhile="${this.doWhile}">\n <${this.expression}></${this.expression}>\n <description>${this.description}</description>\n </loop>\n`;
    else
      str += `<loop id="${this.id}" x="${this.x}" y="${this.y}" scope="${this.scope}" description="${this.description}" expression="${this.expression}"  copy="${this.copy}" doWhile="${this.doWhile}">\n <description>${this.description}</description>\n </loop>\n`;
    return str;
  }

  parseXML(xmlNode) {}

  getPropsDesc() {
    return {
      details: ["id", "description", "copy", "doWhile"],
    };
  }
}
export default Loop;
