import CamelElement from "../CamelElement";
import { Resources } from "../../utility";
class ClaimCheck extends CamelElement {
  constructor() {
    super();
    this.scope = "ClaimCheck";
    this.parent = "";
    this.inputid = ""; // 线的接入
    this.outputid = ""; // 线的出口
    this.filter = "";
    this.id = "_claimCheck";
    this.key = "";
    this.operation = "";
    this.strategyMethodName = "";
    this.strategyRef = "";
    this.description = "";
  }

  paint(g) {
    if (this._img == null) {
      this._img = Resources.IMG_START_NODE;
    }

    g.save();
    this.color = "#cebee1";
    g.drawOvalBorder(this.x, this.y, this.width, this.height, 10, this.color);
    g.drawImage(this._img, this.x + 10, this.y + 5, this.icon_width / 2, this.icon_height / 2);
    g.setColor(Resources.COLOR.black);
    g.drawText("ClaimCheck" + this.id, this.x + this.width / 6, this.y + this.height / 1.5);
    g.restore();
  }

  toXML() {
    let str = "";
    str += `<claimCheck id="${this.id}" x="${this.x}" y="${this.y}" scope="${this.scope}"  filter="${this.filter}" id="${this.id}" key="${this.key}" operation="${this.operation}" strategyMethodName="${this.strategyMethodName}" strategyRef="${this.strategyRef}" description="${this.description}">\n <description>${this.description}</description>\n </claimCheck>\n`;
    return str;
  }

  parseXML(xmlNode) {}

  getPropsDesc() {
    return {
      details: ["filter", "id", "key", "operation", "strategyMethodName", "strategyRef", "description"],
    };
  }
}
export default ClaimCheck;
